#pragma once

#include "types.h"
#include <windows.h>
// for 'time_t'
//#include <sys/stat.h>


#define FILE_ERR(_arg) FILE_ERR__##_arg
enum
{
	FILE_ERR__NONE,
#include "file_err.l"
	FILE_ERRS_NUM
};
#undef FILE_ERR


class File
{
private:
	void GetError ();
public:
	bool Open (bool write, bool widechar, const void* filepath);
	bool Close ();
	bool Delete ();
	bool GetSize ();
	bool Timestamp32_To_Filetime64 (u64& filetime, u32 timestamp);
	bool Filetime64_To_Timestamp32 (u32& timestamp, u64 filetime);
	bool GetTime (FILETIME& ft);
	bool SetTime (FILETIME& ft);
// takes 'time_t' (newer MSVC may have set it to 64 bit mode, so I am not using that type)
	bool SetTime (u32 timestamp);
	bool IsNotEOF (bool& is_not_eof);
	bool SetPointer (bool from_current, u64 pos);
	bool Read (void* buf, u32 len);
	bool Write (const void* buf, u32 len);

private:
// sequence check helper
//	bool m_is_opened;
// *helper
	bool m_write;
	HANDLE m_hfile;
public:
	bool m_is_opened;
	u32 m_error;
	u64 m_len;
	u64 m_pos;
};

