// by Alexander Ilyin
//// code pieces do belong to Parallax Software Corporation and Outrage Entertainment Inc.
// written looking by code which is by Parallax Software Corporation
// HOG files
// *for HOG - look 'cfile_init_hogfile()' in "cfile.c" in src of Descent 1 or 2
// *for HOG2 - look 'ReadHogHeader()', 'ReadHogEntry()' in "hog.cpp", 'cf_OpenLibrary()' in "cfile.cpp" in src of "d3edit"

#include "hog.h"
#include "error.h"
//#include <string>
//using namespace std;
#include "pack_top.h"

// this is the story of HOG identification :  need only compare the first three characters with "DHF", and nothing more to do; this is for the case when the file has .hog extension
// otherwise, a more deeper lookout might be necessary, but when a content checkout is being requested explicitly (by something like 'IsOurFile()')


#if 0
Hog::Hog ()
{
	memset (this, 0, sizeof(*this));
}
#endif

bool Hog::TypeSetup ()
{
	bool r;

	r = SetupContainer ();
	if (! r)
		return 0;
	m_entry_data = &m_buf_entry;
	m_entry_len = sizeof(m_buf_entry);
	m_read_swap_filepointer = 0;
	m_name = m_buf_entry.name;
	m_name_always_zero_ended = 1;
// this is enough old pack, so we don't have to expect anything non-ANSI in the names
	m_name_is_ansi = 1;
	m_name_len_max = sizeof(m_buf_entry.name) - 1;
	m_data_len_32 = &m_buf_entry.len;
	m_file_size_max = HOG_ENTRY_FILE_SIZE_MAX;
//	m_entry_reader_post = EntryReaderPost;
	m_entry_form = &Hog::EntryForm;
	m_has_files_num = 0;
// 'MAX_HOGFILES' - 300 files per HOG
	m_entries_num_max = 300;
// + writer-only configuration +
	m_write_default_bytes_entry = 0;
	m_write_are_subdirectories_allowed = 0;
// - writer-only configuration -

	return 1;
}

bool Hog::EntryForm ()
{
	m_buf_entry.len = m_data_len;
	return 1;
}



bool Hog2::SetHdrBuf ()
{
	m_hdr_buf = &m_buf_hdr;
	m_hdr_size = sizeof(m_buf_hdr);
// for write
// *moved to 'Pack'
//	memset ((u8*)&m_buf_hdr + 8, 0xff, sizeof(m_buf_hdr) - 8);
//	memset (&m_buf_hdr, 0xff, sizeof(m_buf_hdr));
	return 1;
}

bool Hog2::HdrParse (bool& is_valid)
{
#if 0
	bool r;

	r = 4 + m_buf_hdr.s.files_num * sizeof(m_buf_entry) == m_buf_hdr.s.data_begin;
	if (! r)
	{
		m_error = PACK_ERR__UNKNOWN_FORMAT;
		return 0;
	}
#else
// the proportional dependence between two values in the header, allows to do an extra identification check
	is_valid = 4 + sizeof(m_buf_hdr) + m_buf_hdr.s.files_num * sizeof(m_buf_entry) == m_buf_hdr.s.data_begin;
#endif
//	m_files_num = m_buf_hdr.s.files_num;

	return 1;
}

bool Hog2::TypeSetup ()
{
	bool r;

	r = SetupContainer ();
	if (! r)
		return 0;
	m_entry_data = &m_buf_entry;
	m_entry_len = sizeof(m_buf_entry);
	m_read_swap_filepointer = 1;
	m_name = m_buf_entry.name;
	m_name_always_zero_ended = 1;
	m_name_len_max = sizeof(m_buf_entry.name) - 1;
	m_data_len_32 = &m_buf_entry.len;
	m_filetimestamp_32 = &m_buf_entry.timestamp;
//	m_entry_reader_post = &Hog2::EntryReaderPost;
	m_entry_form = &Hog2::EntryForm;
	m_write_finish = &Hog2::WriteFinish;
	m_has_files_num = 1;
// not limited
	m_entries_num_max = 0;
// + writer-only configuration +
	m_write_entries_after_data = 0;
	m_write_entries_store_in_a_buf = 1;
	m_write_default_bytes_hdr = 0xff;
// *CD is in the original, but a messy packer (like the one with which was packed "wind5.mn3") may put there a garbage
	m_write_default_bytes_entry = 0xcd;
	m_write_are_subdirectories_allowed = 0;
// - writer-only configuration -

	m_files_num = m_buf_hdr.s.files_num;
	m_data_begin = m_buf_hdr.s.data_begin;
	m_entries_begin = HOG2_TAG_SIZE + HOG2_HDR_SIZE;
// for write
//	memset ((u8*)&m_buf_hdr + 8, 0xff, sizeof(m_buf_hdr) - 8);

	return 1;
}

bool Hog2::EntryForm ()
{
	bool r;

// *'flags' member of a file to open (but not of an entry) has a properties like 'CF_TEXT' for "\r\n" conversions
// *newer, "wind5.mn3" pack doesn't have 'CF_TEXT', nor in .msn, nor in .msg, nor in .lst files of "\r\n" format
// no one of original Descent 3 hog/mn3 files, has other value in it, than 0
// and the 'CF_WRITING' flag could not have here a sense
	m_buf_entry.flags = 0;
	m_buf_entry.len = m_data_len;
	r = m_file.Filetime64_To_Timestamp32 (m_buf_entry.timestamp, *(u64*)&m_filetime);
	return 1;
}

bool Hog2::WriteFinish ()
{
	m_buf_hdr.s.files_num = m_file_ix;
	m_buf_hdr.s.data_begin = m_data_begin;
	return 1;
}

