#pragma once

#include "types.h"
#include "pack_base.h"


// HOG and HOG2 :  situation is the same - the buffer size inside of the HOGs always makes a room to store the ending zero
#if 0
#define HOG_ENTRY_FILE_NAME_BUF_SIZE 13
#define HOG_ENTRY_FILE_NAME_LEN_MAX (HOG_ENTRY_FILE_NAME_BUF_SIZE - 1)
#else
#define HOG_ENTRY_FILE_NAME_LEN_MAX 12
#define HOG_ENTRY_FILE_NAME_BUF_SIZE (HOG_ENTRY_FILE_NAME_LEN_MAX + 1)
#endif
// PSFILENAME_LEN
#define HOG2_ENTRY_FILE_NAME_LEN_MAX 35
#define HOG2_ENTRY_FILE_NAME_BUF_SIZE (HOG2_ENTRY_FILE_NAME_LEN_MAX + 1)
#define HOGx_ENTRY_FILE_NAME_BUF_SIZE_MAX (HOG2_ENTRY_FILE_NAME_BUF_SIZE)
#define HOG_ENTRY_FILE_SIZE_MAX 0x40000000

#define HOG2_TAG_SIZE 4
#define HOG2_HDR_SIZE 0x40

#pragma pack(push, 1)

struct hog_entry_t
{
	char name[HOG_ENTRY_FILE_NAME_BUF_SIZE];
	u32 len;
};

union hog2_header_t
{
	struct
	{
		u32 files_num;
		u32 data_begin;
	} s;
	char data[HOG2_HDR_SIZE];
};

struct hog2_entry_t
{
	char name[HOG2_ENTRY_FILE_NAME_BUF_SIZE];
	u32 flags;
	u32 len;
	u32 timestamp;
};

#pragma pack(pop)

//class Hog : public Pack
class Hog : virtual public PackBase
//class __declspec(dllexport) Hog : virtual public PackBase
{
public:
//	Hog ();
	bool TypeSetup ();
//	bool EntryReaderPost (bool& is_valid);
	bool EntryForm ();

public:
//	hog_header_t m_buf_hdr;
	hog_entry_t m_buf_entry;
};

class Hog2 : virtual public PackBase
//class __declspec(dllexport) Hog2 : virtual public PackBase
{
public:
//	Hog2 ();
	bool SetHdrBuf ();
	bool HdrParse (bool& is_valid);
	bool TypeSetup ();
//	bool EntryReaderPost (bool& is_valid);
	bool EntryForm ();
	bool WriteFinish ();

public:
	hog2_header_t m_buf_hdr;
	hog2_entry_t m_buf_entry;
};

