// by Alexander Ilyin

#include <windows.h>
//#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
//#include <math.h>
//#include <io.h>
#include <string>
#include <fstream>
//#include <vector>
using namespace std;
#include "vec_str.h"
#include "types.h"
//#include "hog.h"
#include "macros.h"
//#include "plugin.h"
#include "error.h"
#include "pack_export.h"


#define PLUGIN_NAME "pack.wcx"
#define TOTALCMD_API 0
#if TOTALCMD_API
GetFormatNames_t* GetFormatNames_p = 0;
SetProcessDataProc_t* SetProcessDataProc_p = 0;
PackFilesToFile_t* PackFilesToFile_p = 0;
#else
GetFormatNames_t* GetFormatNames_p = 0;
Pack_Create_t* Pack_Create_p = 0;
Pack_Destroy_t* Pack_Destroy_p = 0;
#endif


#define AQUIRE_FUNC(_name) \
	func_name = #_name; \
	*(FARPROC*)&_name##_p = GetProcAddress (hmod, func_name); \
	if (! _name##_p) \
		goto function_get_fail;

bool LoadDLL ()
{
	HMODULE hmod;
	const char* func_name;

	hmod = LoadLibrary (PLUGIN_NAME);
	if (! hmod)
	{
		printf ("failed to load \"" PLUGIN_NAME "\" library file\n");
		return 0;
	}

#if TOTALCMD_API
	func_name = "GetFormatNames";
	*(FARPROC*)&GetFormatNames_p = GetProcAddress (hmod, func_name);
	if (! GetFormatNames_p)
		goto function_get_fail;
	func_name = "SetProcessDataProc";
	*(FARPROC*)&SetProcessDataProc_p = GetProcAddress (hmod, func_name);
	if (! SetProcessDataProc_p)
		goto function_get_fail;
	func_name = "PackFilesToFile";
	*(FARPROC*)&PackFilesToFile_p = GetProcAddress (hmod, func_name);
	if (! PackFilesToFile_p)
		goto function_get_fail;
#else
	AQUIRE_FUNC(GetFormatNames);
	AQUIRE_FUNC(Pack_Create);
	AQUIRE_FUNC(Pack_Destroy);
#endif

	return 1;

function_get_fail:
	printf ("failed to get address of '%s()' subr. from \"" PLUGIN_NAME "\" library\n", func_name);
	return 0;
}

#if TOTALCMD_API
int __stdcall ProcessDataProc (char* filename, int size)
{
	static u32 bytes_processed = 0;

	bytes_processed += size;
	printf ("bytes processed :  %u\n", bytes_processed);
	printf ("file :  \"%s\"\n", filename);

	return 1;
}

int main (int argc, char* argv[])
{
	bool r;
//	bool result;
//	FILE* fo;
//	FILE* fl;
	ifstream fl;
//	int i;
	u32 pack_result;
	const char* add_list;
	string s;
	string s1;

//	__asm int 3

//	result = 0;
//	fo = 0;
//	fl = 0;

#if 0
	FILE* f;
// works
//	f = fopen ("_test/1.HOG", "rb");
	f = fopen ("./_test/1.HOG", "rb");
// doesn't work
//	f = fopen ("/_test/1.HOG", "rb");
	f = f;
#endif

#if 1
	char cur_dir[1024];
	DWORD D;

//	D = GetCurrentDirectory (sizeof(cur_dir), cur_dir);
	D = GetCurrentDirectory (sizeof(cur_dir) - 1, cur_dir);
	if (! D)
	{
		printf ("GetCurrentDirectory() failed\n");
		return -1;
	}
	if (D > sizeof(cur_dir) - 1)
	{
		printf ("path for the current directory is too long ('GetCurrentDirectory()' required a bigger buffer of %u characters, than given one of %u size)\n", D - 1, sizeof(cur_dir) - 1);
		return -1;
	}
#if 0
	printf ("current directory is :\n");
	printf ("\"%s\"\n", cur_dir);
#endif
#endif

#if 0
	FORI0(argc)
	{
		printf ("%s\n", argv[i]);
	}
#endif

	r = LoadDLL ();
	if (! r)
		goto exit_with_error;

	if (argc != 4)
	{
		printf ("need exactly 3 arguments, got %u\n", argc - 1);
		goto print_usage;
	}

#if 0
//	fo = fopen (argv[2], "wb");
//	fl = fopen (argv[2], "rb");
	fl = fopen (argv[3], "r");
	if (! fl)
#else
	fl.open (argv[3]);
	if (! fl)
#endif
	{
		printf ("couldn't open list file \"%s\"\n", argv[3]);
		goto exit_with_error;
	}

// fill the string with file names from the list
	while (! fl.eof())
	{
		getline (fl, s);
// there will be no EOF signalled after the last line end; exclude that case
		if (s.empty())
			continue;
// append the filename together with its ending 0
		s1.append(s.c_str(), s.length() + 1);
	}

#if 0
	i = fclose (fl);
#else
	fl.close ();
#endif

	add_list = s1.c_str();
	A(SetProcessDataProc_p);
// *give any handle for the first argument
	SetProcessDataProc_p (ProcessDataProc, ProcessDataProc);
	A(PackFilesToFile_p);
#if 0
	r = PackFilesToFile_p (pack_result, argv[1], argv[2], 0, add_list);
#else
	strcat (cur_dir, "\\");
	r = PackFilesToFile_p (pack_result, argv[1], argv[2], cur_dir, add_list);
#endif
	if (! r)
	{
//		printf ("**<some error %u>\n", pack_result);
		A(pack_result < NUMOF(pack_errors));
		printf ("error :  %s\n", pack_errors[pack_result]);
//		goto finish;
		goto exit_with_error;
	}

//	result = 1;
	printf ("done packing\n");

#if 0
finish:
	if (! result)
		goto exit_with_error;
#endif
	return 0;

print_usage:
	printf ("usage :  pack.exe <format> <output file> <list file>\n");
//	printf ("for list of formats look ___\n");
	const char** format_names_list;
	u32 names_num;
	A(GetFormatNames_p);
	GetFormatNames_p (format_names_list, names_num);
	printf ("supported formats are :\n");
	{
	FORII0(names_num)
	{
		if (ii)
			printf (", ");
		printf ("%s", format_names_list[ii]);
	}
	}
	printf ("\n");
//wait_for_exit_with_error:
exit_with_error:
#if 1
	printf ("press any key to exit\n");
	while (1)
	{
		if (_kbhit ())
			break;
		Sleep (50);
	}
#endif
	return -1;
}
#else
int main (int argc, char* argv[])
{
	bool r;
//	u32 i;
	PackExports* pack;
//	const char* dir_path;
	string dir_path;
	const char* format;
	const char* output_filepath;
	const char* list_file;
	ifstream fl;
	string s;
	vec_str_t lst;
	u32 files_num;

#if 1
	char cur_dir[1024];
	DWORD D;

//	D = GetCurrentDirectory (sizeof(cur_dir), cur_dir);
	D = GetCurrentDirectory (sizeof(cur_dir) - 1, cur_dir);
	if (! D)
	{
		printf ("GetCurrentDirectory() failed\n");
		return -1;
	}
	if (D > sizeof(cur_dir) - 1)
	{
		printf ("path for the current directory is too long ('GetCurrentDirectory()' required a bigger buffer of %u characters, than given one of %u size)\n", D - 1, sizeof(cur_dir) - 1);
		return -1;
	}
#if 0
	printf ("current directory is :\n");
	printf ("\"%s\"\n", cur_dir);
#endif
#endif

#if 0
	FORI0(argc)
	{
		printf ("%s\n", argv[i]);
	}
#endif

	r = LoadDLL ();
	if (! r)
		goto exit_with_error;

	if (argc != 4)
//	if (argc != 3)
	{
		printf ("need exactly 3 arguments, got %u\n", argc - 1);
//		printf ("need exactly 2 arguments, got %u\n", argc - 1);
		goto print_usage;
	}

	format = argv[1];
	output_filepath = argv[2];
	list_file = argv[3];

// == read list ==

	fl.open (list_file);
	if (! fl)
	{
		printf ("couldn't open list file \"%s\"\n", list_file);
		goto exit_with_error;
	}

// fill the string with file names from the list
	while (! fl.eof())
	{
		getline (fl, s);
// there will be no EOF signalled after the last line end; exclude that case
		if (s.empty())
			continue;
		lst.push_back(s);
	}

	fl.close ();

	files_num = lst.size();
//// *yet this report is necessary; it appears at the beginning, and means :  we began to work
//	printf ("files to pack :  %u\n", files_num);

// == pack ==

	dir_path = cur_dir;
	dir_path += '\\';

//	__asm int 3
	A(Pack_Create_p);
	pack = Pack_Create_p ();
	if (! pack)
	{
//		printf ("failed to create 'Pack' class (out of memory ?)\n");
		printf ("failed to create 'Pack' class (out of memory)\n");
		goto exit_with_error;
	}

	r = pack->SetHandlerByName (format);
	if (! r)
	{
		printf ("failed to set \"%s\" outpu format\n", format);
		goto pack_error;
	}

	r = pack->Open (1, 0, output_filepath);
	if (! r)
	{
		printf ("failed to open file \"%s\"\n", output_filepath);
		goto pack_error;
	}

	r = pack->PrepareHdr (files_num);
	if (! r)
	{
		printf ("failed to prepare header for %u files\n", files_num);
		goto pack_opened_error;
	}

	{
#if 0
	FOREACH(it, lst)
	{
		const char* filepath;
		filepath = it->c_str();
		r = pack->CopyFromFile (0, dir_path.c_str(), filepath);
		if (! r)
		{
			printf ("failed to add file \"%s\" to \"%s\"\n", filepath, output_filepath);
			goto pack_opened_error;
		}
		printf ("file packed :  \"%s\"\n", filepath);
	}
#else
	FORI0(files_num)
	{
		const char* filepath;
		filepath = lst[i].c_str();
// yes, may add 1 at ix, but whatever ...
		printf ("%u/%u file packing :  \"%s\"\n", i, files_num, filepath);
		r = pack->CopyFromFile (0, dir_path.c_str(), filepath);
		if (! r)
		{
			printf ("failed to add file \"%s\" to \"%s\"\n", filepath, output_filepath);
			goto pack_opened_error;
		}
//		printf ("%u/%u file packed :  \"%s\"\n", i + 1, files_num, filepath);
	}
#endif
	}

	r = pack->FinishWrite ();
	if (! r)
	{
		printf ("failed to finish file \"%s\" write\n", output_filepath);
		goto pack_opened_error;
	}

	r = pack->Close ();
	if (! r)
	{
		printf ("failed to close file \"%s\"\n", output_filepath);
		goto pack_error;
	}

	A(Pack_Destroy_p);
	Pack_Destroy_p (pack);

	printf ("done packing\n");

	return 0;

print_usage:
	printf ("usage :  pack.exe <format> <output file> <list file>\n");
	const char** format_names_list;
	u32 names_num;
	A(GetFormatNames_p);
	GetFormatNames_p (format_names_list, names_num);
	printf ("supported formats are :\n");
	{
	FORII0(names_num)
	{
		if (ii)
			printf (", ");
		printf ("%s", format_names_list[ii]);
	}
	}
	printf ("\n");
	goto exit_with_error;

pack_opened_error:
	u32 err;
	err = pack->m_error;
	r = pack->Delete ();
	r = pack->Close ();
	pack->m_error = err;
pack_error:
	A(pack->m_error < NUMOF(pack_errors));
	printf ("error :  %s\n", pack_errors[pack->m_error]);
	goto exit_with_error;

exit_with_error:
#if 1
	printf ("press any key to exit ...");
	while (1)
	{
		if (_kbhit ())
			break;
		Sleep (50);
	}
	printf ("\n");
#endif
	return -1;
}
#endif

