// by Alexander Ilyin
// poly-pack oriented class, for a file-per-once operations
// if need a browse-for-files operations, then it must be implemented on a higher level
// *don't reuse an instance of this; if need reuse, then zero it before, because here are multiple of variables, which values are not always being updated

#include "pack_base.h"
#include "error.h"
#include <string>
using namespace std;
//#include <ansiapi.h>
#include "macros.h"
#include "pack_top.h"
//extern pack_handler_t pack_handlers[];
//extern u32 pack_handlers_num;


// there are three kinds of order in packs :
// 1) continuous :  hdr,-name-length-data,-name-length-data, ...
// 2) hdr,-entries,-datas
// 3) hdr,-datas,-entries
// for 1) :  m_read_swap_filepointer = 0
// for 2) :  m_read_swap_filepointer = 1, m_write_entries_after_data = 0, m_write_entries_store_in_a_buf = 1
// for 3) :  m_read_swap_filepointer = 1, m_write_entries_after_data = 1, m_write_entries_store_in_a_buf = 1

// these macros are 'W2A()' and 'A2W()' from <ansiapi.h> of MSVC 6.0, but that file or these macros are not present in MSVC 8.0
#define WTOA(_w, _a, _cb) WideCharToMultiByte (CP_ACP, 0, _w, -1, _a, _cb, 0,0)
#define ATOW(_a, _w, _cb) MultiByteToWideChar (CP_ACP, 0, _a, -1, _w, _cb)

// test
#if 0
PackBase* this_pack = 0;
u32 this_pack_size = sizeof(Pack);
#endif


#if 1
// stubs for a trick to replace '__if_exists()'/'__if_not_exists()' for MSVC 6.0
bool PackBase::SetHdrBuf ()
{
#if 1
	ET;
	return 0;
#else
	return 1;
#endif
}
bool PackBase::HdrParse (bool& is_valid)
{
#if 1
	ET;
	return 0;
#else
	is_valid = 1;
	return 1;
#endif
}
bool PackBase::TypeSetup ()
{
#if 1
	ET;
	return 0;
#else
	return 1;
#endif
}
#endif

#if 0
PackBase::Pack ()
{
}
#endif

void PackBase::ConvertError ()
{
#if 0
	switch (m_file.m_error)
	{
	case FILE_ERR__NONE:
//		return 0;
// this function should not be called if there was no error
// (theoretically it could be called in any case, but for now I made it to be called only in the case of an error)
		ET;
	case FILE_ERR__OUT_OF_MEMORY:
		m_error = PACK_ERR__OUT_OF_MEMORY;
		break;
	case FILE_ERR__UNSPECIFIED_OPEN_FOR_READ_ERROR:
		m_error = PACK_ERR__UNSPECIFIED_OPEN_FOR_READ_ERROR;
		break;
	case FILE_ERR__UNSPECIFIED_OPEN_FOR_WRITE_ERROR:
		m_error = PACK_ERR__UNSPECIFIED_OPEN_FOR_WRITE_ERROR;
		break;
	case FILE_ERR__NO_FILE:
		m_error = PACK_ERR__NO_FILE;
		break;
	case FILE_ERR__NO_ACCESS:
		m_error = PACK_ERR__NO_ACCESS;
		break;
	case FILE_ERR__CLOSE_ERROR:
		m_error = PACK_ERR__CLOSE_ERROR;
		break;
	case FILE_ERR__UNSPECIFIED_DELETE_ERROR:
		m_error = PACK_ERR__UNSPECIFIED_DELETE_ERROR;
		break;
	case FILE_ERR__READ_FAULT:
		m_error = PACK_ERR__READ_FAULT;
		break;
	case FILE_ERR__INCOMPLETE_READ:
//// should be dispatched
//		ET;
		m_error = PACK_ERR__READ_FAULT;
		break;
	case FILE_ERR__WRITE_FAULT:
		m_error = PACK_ERR__WRITE_FAULT;
		break;
	case FILE_ERR__DISK_FULL:
		m_error = PACK_ERR__DISK_FULL;
		break;
	default:
		ET;
	}
#endif
#if 0
	if (! m_file.m_error)
		ET;
	if (m_file.m_error >= FILE_ERRS_NUM)
		ET;
#endif
	A(m_file.m_error);
	A(m_file.m_error < FILE_ERRS_NUM);
	m_error = m_file.m_error;
// umhm, and that actually is it :)

//	return 0;
}

bool PackBase::Open (bool write, bool widechar, const void* filepath)
{
	bool r;

//// *it also actually zeroes the content of 'm_file'
//	memset (this, 0, sizeof(*this));
// test
//	memset (&m_file, 0, sizeof(m_file));
// test
//	this_pack = this;
//	A(! m_is_opened);
//	m_write = write;
	A(m_pack_top);
// small check - were we zeroed or not
	A(! m_error);

	m_error = -1;

	r = m_file.Open (write, widechar, filepath);
	if (! r)
		goto file_error;

//	m_is_opened = 1;
	m_error = 0;
	return 1;

file_error:
	ConvertError ();
	return 0;
}

bool PackBase::Close ()
{
	bool r;

//	A(m_is_opened);
	m_error = -1;
	r = m_file.Close ();
	if (! r)
	{
		ConvertError ();
		return 0;
	}
//	m_is_opened = 0;
	m_error = 0;
	return 1;
}

bool PackBase::Delete ()
{
	bool r;

//	A(m_is_opened);
	m_error = -1;
	r = m_file.Delete ();
	if (! r)
	{
		ConvertError ();
		return 0;
	}
	m_error = 0;
	return 1;
}

// *temp hack
#if 1
#define m_handlers_array pack_handlers
#define m_handlers_num pack_handlers_num
#endif

// one of ways to choose the format
// *currently - the only
//bool PackBase::SetHandlerByTag (const char* tag)
bool PackBase::SetHandlerByName (const char* name)
{
	bool r;

	A(m_handlers_array);
	A(m_handlers_num);
	m_error = -1;
	pack_handler_t* handler;

	FORI0(m_handlers_num)
	{
		handler = &m_handlers_array[i];
//		if (! strcmp (handler->tag, tag))
		if (! _stricmp (handler->name, name))
			goto setup_handler;
	}

	m_error = PACK_ERR__UNKNOWN_FORMAT;
	return 0;

setup_handler:
	m_handler = handler;
	if (handler->set_hdr_buf)
	{
		r = (m_pack_top->*handler->set_hdr_buf) ();
		if (! r)
			return 0;
	}
	A(handler->pack_type_setup);
	A(handler->pack_type_setup != &PackBase::TypeSetup);
//	r = handler->pack_type_setup ();
	r = (m_pack_top->*handler->pack_type_setup) ();
	if (! r)
		return 0;

	m_error = 0;
	return 1;
}

// *I have a feeling that I must take some part of this subroutine, and move to 'PackTop', but I have no clear vision on what to take from here
bool PackBase::ReadHdr ()
{
	bool r;
	u32 len;
	u32 tag_len;
	bool is_our;
	pack_handler_t* handler;

//	A(m_is_opened);
	A(m_handlers_array);
	A(m_handlers_num);
	m_error = -1;

// read operations will need to know the size of the file
	r = m_file.GetSize ();
	if (! r)
		goto file_error;

// read some amount of data at the beginning of the file
	len = min(m_file.m_len, sizeof(m_buf_for_tag));
	r = m_file.Read (m_buf_for_tag, len);
	if (! r)
		goto file_error;

// satisfy MSVC 6.0 compiler
	{
	FORI0(m_handlers_num)
	{
		handler = &m_handlers_array[i];
		tag_len = 0;
		if (handler->tag)
		{
			tag_len = strlen (handler->tag);
			A(tag_len <= sizeof(m_buf_for_tag));
			if (memcmp (m_buf_for_tag, handler->tag, tag_len))
				continue;
		}
// we have spoiled the position of the pointer; reset it
		r = m_file.SetPointer (0, tag_len);
		if (! r)
			goto file_error;
//		m_compound_offset_cur = tag_len;
#if 0
		if (handler->header)
		{
			A(handler->header_len);
			r = m_file.Read (handler->header, handler->header_len);
			if (! r)
				goto file_error;
		}
#else
		m_hdr_buf = 0;
		m_hdr_size = 0;
		if (handler->set_hdr_buf)
		{
			r = (m_pack_top->*handler->set_hdr_buf) ();
			if (! r)
				return 0;
		}
		if (m_hdr_buf)
		{
			A(m_hdr_size);
			r = m_file.Read (m_hdr_buf, m_hdr_size);
			if (! r)
				goto file_error;
		}
#endif
//		A(handler->header_parse);
// hmmm, "fatal error C1001: INTERNAL COMPILER ERROR"
//		if (! handler->header_parse)
		if (handler->header_parse == 0)
			goto setup_handler;
//		r = handler->header_parse (is_our);
		r = (m_pack_top->*handler->header_parse) (is_our);
		if (! r)
			return 0;
// is this format of this handler
		if (is_our)
			goto setup_handler;
	}
	}
	goto unknown_format;

setup_handler:
	m_handler = handler;
//// 'Xxx::TypeSetup' is not optional
// 'Xxx::TypeSetup' is not optional in any way
	A(handler->pack_type_setup);
	A(handler->pack_type_setup != &PackBase::TypeSetup);
// *don't reuse this class after this
//	r = handler->pack_type_setup ();
	r = (m_pack_top->*handler->pack_type_setup) ();
	if (! r)
		return 0;
// pack of two blocks needs to know how much files it has; continuous package doesn't need that
	A(! m_read_swap_filepointer || m_has_files_num);
// for a while it is so
	A(m_read_swap_filepointer == m_write_entries_store_in_a_buf);

// nah, don't do this on conditions; do it unconditionally (there may appear a reason to use it)
//	if (! m_filetime_64)
	{
//		if (! m_filetimestamp_32)
// this pack has no filetimes in it; take the time of the pack file itself instead
		{
			r = m_file.GetTime (m_packfile_filetime);
			if (! r)
				goto file_error;
//			goto finish;
		}
	}

	if (m_has_files_num)
	{
		if (m_entries_num_max)
		{
			if (m_files_num > m_entries_num_max)
			{
				m_error = PACK_ERR__TOO_MUCH_ENTRIES;
				return 0;
			}
		}
	}

// of single block
//	m_compound_offset_cur = m_file.m_pos;
// of two blocks
	m_entry_offset_cur = m_entries_begin;
	m_data_offset_cur = m_data_begin;

//finish:
	m_error = 0;
	return 1;

unknown_format:
	m_error = PACK_ERR__UNKNOWN_FORMAT;
	return 0;

file_error:
	ConvertError ();
	return 0;
}

//bool PackBase::WriteHdr (u32 files_num)
bool PackBase::PrepareHdr (u32 files_num)
{
	bool r;

	A(m_handler);
	m_error = -1;

	if (m_entries_num_max)
	{
		if (files_num > m_entries_num_max)
		{
			m_error = PACK_ERR__TOO_MUCH_ENTRIES;
			return 0;
		}
	}

	m_data_begin = 0;
	m_files_num = files_num;
	if (m_handler->tag)
	{
		m_data_begin += strlen(m_handler->tag);
	}
// cleanup with default values (this mostly matters for the "background" under the filenames, when a filename is shorter than its buffer)
	if (m_hdr_buf)
	{
		memset (m_hdr_buf, m_write_default_bytes_hdr, m_hdr_size);
		m_data_begin += m_hdr_size;
	}
	m_data_offset_cur = m_data_begin;

//// *it will be used in an assertion below
//	m_entries_begin = m_data_begin;

	if (m_write_entries_store_in_a_buf)
	{
		m_write_entries_buf_size = m_entry_len * m_files_num;
		m_write_entries_buf = malloc (m_write_entries_buf_size);
		if (! m_write_entries_buf)
		{
			m_error = PACK_ERR__OUT_OF_MEMORY;
			return 0;
		}
//		memset (m_write_entries_buf, m_write_default_bytes_entry, m_write_entries_buf_size);
		m_write_entry_cur = m_write_entries_buf;

		if (! m_write_entries_after_data)
		{
// *almost no sense, because we couldn't know its pos on the otherwise case; but it will be used in an assertion below
			m_entries_begin = m_data_begin;
			m_data_begin += m_write_entries_buf_size;
		}
	}

// *'m_data_begin' is for a two-block file, but here it also is used for a continuous file (single-block)
	r = m_file.SetPointer (0, m_data_begin);
	if (! r)
		goto file_error;

	m_error = 0;
	return 1;

file_error:
	ConvertError ();
	return 0;
}

// set the mandatory properties of the container
// *there are no variables which are required to be set mandatory, but this function is necessary anyway, because there possibly may appear a need to initialize some var to some literal value other than 0
bool PackBase::SetupContainer ()
{
// *nothing here for a while - all default values are zeroes for a while
	return 1;
}

bool PackBase::HasMoreFiles (bool& has_more)
{
//	bool r;

//	A(m_is_opened);
	has_more = 0;
	m_error = -1;

// a pack must normally have the total number of files which it has
	if (m_has_files_num)
	{
		has_more = m_file_ix < m_files_num;
		goto finish;
	}

	A(! m_read_swap_filepointer);
	has_more = m_file.m_pos < m_file.m_len;

finish:
	m_error = 0;
	return 1;
}

// *call 'HasMoreFiles()' before that, otherwise it will report about a bad header
bool PackBase::ReadEntry ()
{
	bool r;
	bool is_valid;

	if (m_has_files_num)
	{
		A(m_file_ix < m_files_num);
	}

	if (m_read_swap_filepointer)
	{
		if (m_entry_offset_cur != m_file.m_pos)
		{
			r = m_file.SetPointer (0, m_entry_offset_cur);
			if (! r)
				goto file_error;
		}
	}

	if (m_entry_reader)
	{
// *the argument of this function isn't enough clear; if it is - then explain it here
		r = (m_pack_top->*m_entry_reader) (is_valid);
		if (! r)
			return 0;
		if (! is_valid)
			goto bad_entry;
	}

//// doesn't have an entry
// isn't required to parse the entry
	if (! m_entry_data)
// *hmmm, I don't know, it more looks like the name for thaf file should be generated here, rather than in our caller or the pack handler
// or yet maybe in the caller
		goto succeed;

//// check if the entry doesn't overlap upon the data
//// *EOF case doesn't need to be checked here - it would hit later, at read time
//// *actually, EOF should also be checked here, but I am not implementing it now ...
// check if the entry doesn't go beyond EOF, and doesn't overlap upon the data
	if (m_read_swap_filepointer)
	{
// can't :)
//		A(m_write_entries_after_data == m_entries_begin >= m_data_begin);
		A(m_entry_offset_cur >= m_entries_begin);
//// the case when the entries are before the data
//		if (m_entries_begin < m_data_begin)
		if (m_write_entries_after_data)
		{
			if (m_entry_offset_cur + m_entry_len > m_file.m_len)
				goto bad_entry;
		}
		else
		{
			if (m_entry_offset_cur + m_entry_len > m_data_begin)
				goto bad_entry;
		}
	}

//	A(m_is_opened);
//	A(! m_write);
	m_error = -1;

	r = m_file.Read (m_entry_data, m_entry_len);
	if (! r)
	{
		if (m_file.m_error == FILE_ERR__INCOMPLETE_READ)
			goto bad_entry;
		goto file_error;
	}
// increment now, because soon may return 0, while there is no error; for example to skip the entry
	m_entry_offset_cur += m_entry_len;

// test
#if 0
	if (((Hog2*)m_pack_top)->m_buf_entry.flags)
		m_pack_top = m_pack_top;
#endif

// 1st property of a file :  length
	if (m_data_len_32)
		m_data_len = *m_data_len_32;
	else
		ET;
// check that the filename length would be meaningful
	if (m_file_size_max)
	{
		if (0 >= m_file_size_max)
		{
			m_error = PACK_ERR__FILE_TOO_BIG;
			return 0;
		}
	}

// 2nd property of a file :  name
// maybe the upper class wants to get it on its own
	if (m_entry_get_name)
	{
		r = (m_pack_top->*m_entry_get_name) ();
		if (! r)
			return 0;
	}

// unnecessary :  we don't copy the names
#if 0
	if (m_name_n)
// the filename in the entry may not be 0 ended, so have to copy it and put the 0
	{
		A(m_name_len_max);
		memcpy (m_name, m_name_n, m_name_len_max);
		m_name[m_name_len_max] = 0;
	}
#endif
// unnecessary anymore, because the filenames are checked/validated in the pack handler
#if 0
	else
// the filename is always 0 ended; however, we still must ensure 0 ending, if we know where to put the 0
	{
		if (m_name_len_max)
			m_name[m_name_len_max] = 0;
	}
#endif
// if a pack promises to have 0-endings applied at names in it, we may use it as an extra check
	u32 i;
	if (m_name_always_zero_ended)
	{
		for (i = 0; i <= m_name_len_max; i++)
		{
			char c;
			c = m_name[i];
// 0 must be present, but not on the first character
			if (! c)
			{
				if (! i)
					goto bad_entry;
				break;
			}
			if (! m_name_is_ansi)
				continue;
// do not expect anything non-ASCII-like or UTF-8
			if (c < 0x20)
				goto bad_entry;
			if (c >= 0x80)
				goto bad_entry;
		}
	}

// 3rd property of a file :  time
	if (m_filetime_64)
	{
		m_filetime = *m_filetime_64;
	}
	else if (m_filetimestamp_32)
	{
		u64 filetime;
		filetime = 0;
		r = m_file.Timestamp32_To_Filetime64 (filetime, *m_filetimestamp_32);
		if (! r)
			goto use_packfile_filetime;
		m_filetime = *(FILETIME*)&filetime;
	}
	else
use_packfile_filetime:
		m_filetime = m_packfile_filetime;

	if (m_data_offset_32)
	{
		m_data_offset_cur = *m_data_offset_32;
	}

// check if the data doesn't overlap upon the entries
	if (m_read_swap_filepointer)
	{
		if (m_data_offset_cur < m_data_begin)
// doubtlessly :  this entry points to invalid location, thus is invalid
			goto bad_entry;
//		if (m_data_offset_cur >= m_file.m_len)
//			goto bad_entry;
		if (m_write_entries_after_data)
		{
			A(m_data_begin <= m_entries_begin);
			if (m_data_offset_cur + m_data_len > m_entries_begin)
// doubtlessly :  this entry points to invalid location, thus is invalid
				goto bad_entry;
		}
		else
		{
			A(m_entries_begin <= m_data_begin);
//// data goes outside of the file :  it may be both, and an invalid entry, and an incomplete file; more likely it is an incomplete file
			if (m_file_end)
			{
				if (m_data_offset_cur + m_data_len > m_file_end)
// data goes outside of the file :  this is an invalid entry
					goto bad_entry;
			}
			if (m_data_offset_cur + m_data_len > m_file.m_len)
// data goes outside of the file :  this is an incomplete file
				goto bad_file;
		}
	}

	if (m_entry_reader_post)
	{
		r = (m_pack_top->*m_entry_reader_post) (is_valid);
		if (! r)
			return 0;
		if (! is_valid)
			goto bad_entry;
	}

succeed:
	m_error = 0;
	return 1;

file_error:
	ConvertError ();
	return 0;

//// *it is not always easy to define - is it a bad entry or a bad data, so I am simplifying the algo
bad_entry:
	m_error = PACK_ERR__BAD_ENTRY;
	return 0;

bad_file:
	m_error = PACK_ERR__BAD_FILE;
	return 0;
}

bool PackBase::GetEntryNameRequiredBufSize (u32& buf_size)
{
	buf_size = m_name_len_max + 1;
	m_error = 0;
	return 1;
}

bool PackBase::GetEntryName (char* buf)
{
	memcpy (buf, m_name, m_name_len_max);
// ensure 0 ending
	buf[m_name_len_max] = 0;
	m_error = 0;
	return 1;
}

bool PackBase::WriteEntry ()
{
	bool r;

	m_error = -1;

// *no idea what it could be (and accordingly - how to realize that)
#if 0
	if (m_entry_writer)
	{
		r = (m_pack_top->*m_entry_writer) ();
		if (! r)
		{
			A(m_error);
			return 0;
		}
		return 1;
	}
#endif

// note, that we actually could form the entry ourselves, since we often have enough info about it, but better lets let the handler to do it
	A(m_entry_form);
//	if (m_entry_form)
//	{
		r = (m_pack_top->*m_entry_form) ();
		if (! r)
			return 0;
//	}

	if (m_write_entries_store_in_a_buf)
// copy to buf
	{
		memcpy (m_write_entry_cur, m_entry_data, m_entry_len);
		*(u8**)&m_write_entry_cur += m_entry_len;
	}
	else
// write
	{
		r = m_file.Write (m_entry_data, m_entry_len);
		if (! r)
			goto file_error;
	}

	return 1;

file_error:
	ConvertError ();
	return 0;
}

//bool PackBase::SkipFile ()
bool PackBase::SkipFileData ()
{
	bool r;

	if (m_read_swap_filepointer)
	{
//// no operation
//// *this normally should not be necessary, but expect, that there could be a silly format, which doesn't have a pointer to data in each its entry
		m_data_offset_cur += m_data_len;
		goto succeed;
	}

//	A(m_is_opened);
	m_error = -1;

	r = m_file.SetPointer (1, m_data_len);
	if (! r)
	{
		ConvertError ();
		return 0;
	}
//	m_len = 0;

succeed:
	m_data_bytes_processed += m_data_len;
	m_file_ix++;
	m_error = 0;
	return 1;
}

// these functions became a bit extra
#if 0
bool PackBase::ReadToMem ()
{
	bool r;

//	A(! m_write);
	m_error = -1;

	r = m_file.Read (m_mem, m_data_len);
#if 1
	if (! r)
		return 0;
#else
	if (! r)
	{
		ConvertError ();
		return 0;
	}
	m_error = PACK_ERR__NONE;
#endif

	return 1;
}

bool PackBase::WriteFromMem ()
{
	bool r;

//	A(m_write);
	m_error = -1;

	r = m_file.Write (m_mem, m_data_len);
	if (! r)
		return 0;

	return 1;
}
#endif

bool PackBase::CopyToFile_Mallocated (bool widechar, const void* filepath)
{
	bool r;
	File fo;
//	File fo = {0};

	memset (&fo, 0, sizeof(fo));

	r = fo.Open (1, widechar, filepath);
	if (! r)
		goto file_out_error;

	r = m_file.Read (m_mem, m_data_len);
	if (! r)
		goto file_error;
// *some formats do lack of a member for the offset, so have to calculate it by the length of included files
	m_data_offset_cur += m_data_len;

	r = fo.Write (m_mem, m_data_len);
	if (! r)
		goto file_out_error;

// change the time when the file was modified
	r = fo.SetTime (m_packfile_filetime);
	if (! r)
		goto file_out_error;

	m_error = PACK_ERR__NONE;

finish:
	if (fo.m_is_opened)
	{
// remove this file, if an error there has occured
		if (m_error)
		{
			r = fo.Delete ();
//			if (! r)
//				goto maybe_get_fo_error;
			if (! r)
			{
				if (! m_error)
				{
					m_file.m_error = fo.m_error;
					ConvertError ();
				}
			}
		}
		r = fo.Close ();
		if (! r)
//maybe_get_fo_error:
		{
			if (! m_error)
			{
				m_file.m_error = fo.m_error;
				ConvertError ();
			}
		}
	}
//	return 1;
	return ! m_error;

file_out_error:
	m_file.m_error = fo.m_error;
file_error:
	ConvertError ();
	A(m_error);
//	return 0;
	goto finish;
}

// copy data from under the current pointer, and of 'm_data_len' length into a file
bool PackBase::CopyToFile (bool widechar, const void* filepath)
{
	bool r;

	if (m_read_swap_filepointer)
	{
// *there is no sense to switch the file pointer, if there will be no data to read
		if (m_data_len)
		{
			r = m_file.SetPointer (0, m_data_offset_cur);
			if (! r)
				goto file_error;
		}
	}

//	m_error = -1;

//	A(! m_write);
	A(! m_mem);

	m_mem = malloc (m_data_len);
	if (! m_mem)
	{
		m_error = PACK_ERR__OUT_OF_MEMORY;
		return 0;
	}

	r = CopyToFile_Mallocated (widechar, filepath);
	if (! r)
	{
		A(m_error);
		goto finish;
	}

	m_data_bytes_processed += m_data_len;
	m_file_ix++;
//	m_error = 0;

finish:
	free (m_mem);
	m_mem = 0;
//	return 1;
	return ! m_error;

file_error:
	ConvertError ();
	return 0;
}

// the characters of it must be in 0x20-0x80 range
// (there is no such limitation in the actual HOG, but just I am using it for HOG identification; and such a check actually will not harm)
bool PackBase::CheckFileNameForEntry ()
//bool PackBase::CheckFileNameForEntry_OnANSI ()
{
	char c;
	const char* ptr;

	A(m_name);
	A(m_name_always_zero_ended);
	A(m_name_is_ansi);
	ptr = m_name;
	if (! *ptr)
//		return 0;
		goto inacceptable_filename;
//	m_name_len_max;
	while ((c = *ptr))
	{
//		if (! c)
//			return 1;
		if (c < 0x20)
//			return 0;
			goto inacceptable_filename;
		if (c >= 0x80)
//			return 0;
			goto inacceptable_filename;
		ptr++;
	}
	m_error = 0;
	return 1;

inacceptable_filename:
	m_error = PACK_ERR__FILENAME_INCOMPATIBLE;
	return 0;
}

bool PackBase::PutFileName (bool widechar, const void* filename)
{
	bool r;
	u32 i;
	u32 buf_size;

// that the story :
// here must be conditions on the kind of the necessary output :  is it widechar, has it 0 ending
// but for a while, there only necessary is ANSI output with a buffer which always has 0 ending in it
// so lets just assert it
	A(! m_name_is_widechar);
	A(m_name);
	A(m_name_always_zero_ended);
//	A(m_name_is_ansi);
	A(m_name_len_max);

	m_error = PACK_ERR__FILENAME_INCOMPATIBLE;
	buf_size = m_name_len_max + 1;
// *assume the buffer is already cleaned up

//	if (! m_write_entries_store_in_a_buf)
//		memset (m_name, m_write_default_bytes_entry, buf_size);

// the name must fit in the name entry
	if (widechar)
	{
// get required buffer length
		i = WTOA((wchar_t*)filename, 0, 0);
		if (i > buf_size)
			goto inacceptable_filename;
		i = WTOA((wchar_t*)filename, m_name, buf_size);
// should not fail
		A(i);
	}
	else
	{
//		strncpy (m_name, filename, HOG_ENTRY_FILE_NAME_BUF_SIZE);
		i = strlen ((char*)filename);
		if (i > m_name_len_max)
			goto inacceptable_filename;
		strcpy (m_name, (char*)filename);
	}

// convert \ to /
	char* ptr;
	char c;
	ptr = m_name;
	if (! *ptr)
		goto inacceptable_filename;
//	m_name_len_max;
	while ((c = *ptr))
	{
		if (c == '\\')
		{
			c = '/';
			*ptr = c;
		}
		if (! m_write_are_subdirectories_allowed)
			if (c == '/')
				goto inacceptable_filename;
		ptr++;
	}

	if (m_name_is_ansi)
	{
		r = CheckFileNameForEntry ();
		if (! r)
			return 0;
	}

// *unset
//	m_error = -1;
	m_error = 0;
	return 1;

inacceptable_filename:
	m_error = PACK_ERR__FILENAME_INCOMPATIBLE;
	return 0;
}

// it is not add any convenience if split this function onto a three, including each other; that instead would add a repeated pieces of code, containing 'ConvertError()' calls
bool PackBase::CopyFromFile (bool widechar, const void* path, const void* filename)
{
	bool r;
	File fi;

//	A(m_write);
	A(! m_mem);
	A(path);
	m_error = -1;

// *note, the surrounding is done so, that 'm_file.SetPointer()' is not necessary here

// cleanup the entry buffer
	memset (m_entry_data, m_write_default_bytes_entry, m_entry_len);

	if (m_name)
	{
		r = PutFileName (widechar, filename);
		if (! r)
			return 0;
	}

	memset (&fi, 0, sizeof(fi));

	if (widechar)
	{
		wstring ws;
		ws = (wchar_t*)path;
		ws += (wchar_t*)filename;
		r = fi.Open (0, widechar, ws.c_str());
	}
	else
	{
		string s;
		s = (char*)path;
		s += (char*)filename;
		r = fi.Open (0, widechar, s.c_str());
	}
	if (! r)
		goto file_in_error;

	r = fi.GetSize ();
	if (! r)
		goto file_in_error;
	if (m_file_size_max)
	{
		if (fi.m_len >= m_file_size_max)
		{
			m_error = PACK_ERR__FILE_TOO_BIG;
			goto finish;
		}
	}
	m_data_len = fi.m_len;
	r = fi.GetTime (m_filetime);
	if (! r)
		goto file_in_error;

	r = WriteEntry ();
	if (! r)
		goto finish;

	m_mem = malloc (m_data_len);
	if (! m_mem)
	{
		m_error = PACK_ERR__OUT_OF_MEMORY;
		goto finish;
	}

	r = fi.Read (m_mem, m_data_len);
	if (! r)
		goto file_in_error;

	r = m_file.Write (m_mem, m_data_len);
	if (! r)
		goto file_error;
	m_data_offset_cur += m_data_len;

	m_data_bytes_processed += m_data_len;
	m_file_ix++;
	m_error = PACK_ERR__NONE;

finish:
	if (m_mem)
	{
		free (m_mem);
		m_mem = 0;
	}
	if (fi.m_is_opened)
	{
		r = fi.Close ();
		if (! r)
		{
			if (! m_error)
			{
				m_file.m_error = fi.m_error;
				ConvertError ();
			}
		}
	}
//	return 1;
	return ! m_error;

file_in_error:
	m_file.m_error = fi.m_error;
file_error:
	ConvertError ();
	A(m_error);
//	return 0;
	goto finish;
}

bool PackBase::FinishWrite ()
{
	bool r;
// *no need to truncate the file - it losses its content at open time, in any case
//	u64 file_end;

	A(m_pack_top);
	A(m_handler);
	m_error = -1;

// *'WriteFinish()' may need 'm_entries_begin'
	if (m_write_entries_store_in_a_buf)
	{
//		file_end = m_file.m_pos;
// get 'm_entries_begin'
		if (m_write_entries_after_data)
		{
			m_entries_begin = m_file.m_pos;
//			file_end += m_write_entries_buf_size;
		}
		else
		{
			r = m_file.SetPointer (0, m_entries_begin);
			if (! r)
				goto file_error;
		}
	}

	if (m_write_finish)
	{
		r = (m_pack_top->*m_write_finish) ();
		if (! r)
		{
			A(m_error);
//			return 0;
			goto finish;
		}
	}

	if (m_write_entries_store_in_a_buf)
// write entries
	{
		A(m_write_entries_buf);
		r = m_file.Write (m_write_entries_buf, m_write_entries_buf_size);
		if (! r)
			goto file_error;

// check the position #1 :  we should now be after the entries
		if (m_write_entries_after_data)
		{
		}
		else
		{
			A(m_file.m_pos == m_data_begin);
		}
	}

// got at the beginning of the file
	r = m_file.SetPointer (0, 0);
	if (! r)
		goto file_error;

//	if (m_has_tag)
	if (m_handler->tag)
// write tag
	{
		r = m_file.Write (m_handler->tag, strlen (m_handler->tag));
		if (! r)
			goto file_error;
	}

//write_header:
	if (m_hdr_buf)
// write header
	{
		r = m_file.Write (m_hdr_buf, m_hdr_size);
		if (! r)
			goto file_error;
	}

// check the position #2 :  we should now be after the header
	if (m_write_entries_store_in_a_buf)
	{
		if (m_write_entries_after_data)
		{
// assert this once again
			A(m_write_entries_store_in_a_buf);
			A(m_file.m_pos == m_data_begin);
		}
		else
		{
			A(m_file.m_pos == m_entries_begin);
		}
	}

	m_error = 0;

finish:
	if (m_write_entries_buf)
	{
		free (m_write_entries_buf);
		m_write_entries_buf = 0;
	}
//	return 1;
	return ! m_error;

file_error:
	ConvertError ();
	A(m_error);
//	return 0;
	goto finish;
}

