#pragma once

#include "types.h"
//#include "file.h"
#include "pack_setup.h"


// *a set of errors which may occur at a pack/unpack time
// it more is like a container error
#define PACK_ERR(_arg) PACK_ERR__##_arg
enum
{
	PACK_ERR__NONE,
#define FILE_ERR PACK_ERR
#include "file_err.l"
#undef FILE_ERR
#include "pack_err.l"
	PACK_ERRS_NUM
};
#undef PACK_ERR

#define PACK_ERR(_arg) #_arg
const char* const pack_errors[] =
{
	"<none>",
#define FILE_ERR PACK_ERR
#include "file_err.l"
#undef FILE_ERR
#include "pack_err.l"
	0
};
#undef PACK_ERR


//class __declspec(dllexport) PackExports
//struct __declspec(dllexport) PackExports
struct PackExports
//class PackExports
{
//public:
	virtual bool Open (bool write, bool widechar, const void* filepath) = 0;
	virtual bool Close () = 0;
	virtual bool Delete () = 0;
	virtual bool SetHandlerByName (const char* name) = 0;
// *'ReadHeader()' conflicts at linking
	virtual bool ReadHdr () = 0;
	virtual bool PrepareHdr (u32 files_num) = 0;
	virtual bool HasMoreFiles (bool& has_more) = 0;
	virtual bool ReadEntry () = 0;
	virtual bool GetEntryNameRequiredBufSize (u32& buf_size) = 0;
	virtual bool GetEntryName (char* buf) = 0;
//	virtual bool WriteEntry () = 0;
	virtual bool SkipFileData () = 0;
#if 0
	virtual bool ReadToMem () = 0;
	virtual bool WriteFromMem () = 0;
#endif
	virtual bool CopyToFile (bool widechar, const void* filepath) = 0;
#if 0
	virtual bool CheckFileNameForEntry () = 0;
	virtual bool PutFileName (bool widechar, const void* filename) = 0;
#endif
//	virtual bool CopyFromFile (bool widechar, const void* filepath) = 0;
	virtual bool CopyFromFile (bool widechar, const void* path, const void* filename) = 0;
	virtual bool FinishWrite () = 0;

//public:
// marker for zeroing
	u8 _m_beg;
// this is how to access handlers, which are above us; and this is on what 'delete' must be called
// *note :  could use a virtual destructor for that; that however will not make the code smaller
	PackTop* m_pack_top;
//// *note, that I set it to -1, when the operation is not yet completed/finished (some error still may occur ahead; useable in a private functions)
// *note, that I set it to -1, when the operation is not yet completed/finished (some error still may occur ahead)
	u32 m_error;
};

//PackExports* Pack_Create ();
//void Pack_Destroy (PackExports*& pack);
//#define PACKCALLCONV __stdcall
#define PACKCALLCONV __cdecl
typedef void PACKCALLCONV GetFormatNames_t (const char**& format_names_list, u32& names_num);
typedef PackExports* PACKCALLCONV Pack_Create_t ();
typedef void PACKCALLCONV Pack_Destroy_t (PackExports*& pack);

