#pragma once

#include "types.h"
#include "file.h"


class PackTop;
#if 0
//typedef bool PackTypeCheck_t (bool& is_our);
typedef bool PackHeaderParse_t (bool& is_our);
typedef bool PackTypeSetup_t ();
typedef bool PackEntryReader_t ();
typedef bool PackEntryWriter_t ();
typedef bool PackWriteFinish_t ();
#else
typedef bool (PackTop::*PackSetHdrBuf_t) ();
typedef bool (PackTop::*PackHeaderParse_t) (bool& is_our);
typedef bool (PackTop::*PackTypeSetup_t) ();
// *not need it for a while; but if will need, it should likely be 'Pre' and 'Post' functions, or a common reader and 'Post' functions
typedef bool (PackTop::*PackEntryReader_t) (bool& is_valid);
//typedef bool (PackTop::*PackEntryCheck_t) (bool& is_valid);
//typedef bool (PackTop::*PackEntryReadName_t) ();
typedef bool (PackTop::*PackEntryGetName_t) ();
typedef bool (PackTop::*PackEntryReaderPost_t) (bool& is_valid);
// *could it be necessary ?
//typedef bool (PackTop::*PackEntryWriter_t) ();
typedef bool (PackTop::*PackEntryForm_t) ();
typedef bool (PackTop::*PackWriteFinish_t) ();
#endif

// *it actually is only a recognizer; other functions of the handler are being set up by this recognizer
// *have to put here a minimal possible number of variables, so that it would be easy to fill at the place of array creation
//struct file_type_t
struct pack_handler_t
{
	const char* name;
	const char* extension;
	const char* tag;
#if 0
	void* header;
	u32 header_len;
#endif
#if 0
	void* PackTop::* header;
	u32 header_len;
#endif
//// *there remained a conditions on the presence of these functions - do not give an attention at that - those conditions are always executed
	PackSetHdrBuf_t set_hdr_buf;
// *note, this function doesn't set/tune up configuration of 'Pack'; it only checks the header once again, after the file's tag been checked
	PackHeaderParse_t header_parse;
	PackTypeSetup_t pack_type_setup;
};

// *or use 'HDR_FUNCS_IF_PACK_OVERLOADS_EXIST' instead
#define CLASS_HEADER_FUNCS(_class) &_class::SetHdrBuf, &_class::HdrParse, &_class::TypeSetup

// parameters for this container (the one which has been set up)
class PackSetup
//struct PackSetup
{
public:
// 'Pack' sets it
	pack_handler_t* m_handler;
//	bool m_has_tag;
// 'PackSetHdrBuf_t()' sets it
// *note, that any packs normally do include their tag into the header, but we don't include it
	void* m_hdr_buf;
	u32 m_hdr_size;
//	u32 m_hdr_len;
// == set by 'PackTypeSetup_t()' ==
	void* m_entry_data;
	u32 m_entry_len;
// file content is continuous entry-data-entry-data, otherwise it consists of two monoblocks :  entries and their data
//	bool m_monoblocked;
//	bool m_continuous;
//	bool m_separate_blocks;
//	bool m_two_blocks;
//	bool m_in_two_blocks;
//	bool m_of_two_blocks;
	u32* m_data_offset_32;
// 'm_name' points to a buffer with widechars
	bool m_name_is_widechar;
//// this should always point to a 0-ended name; in the case if the name in the pack is not always 0-ended, this should point to some intermediate buffer
// *note, that we don't guarantee that this name will be 0-ended (when take), so the our caller should copy it from here, and put the ending 0
	char* m_name;
//// *if will want to restore this functionability, make backward :  'm_name' should be the intermediate buffer of 'm_name_len_max + 1' size, and 'm_name_n' should point to the buffer of 'm_name_len_max' size
// 'm_name' is the intermediate buffer of 'm_name_len_max + 1' size, and 'm_name_n' points to the buffer of 'm_name_len_max' size, which is compatible with the entry storage in the file
#if 0
//// set this, if the name may appear not 0 ended, and you want that it would be copied to buffer, pointed by 'm_name'
// set this, if the entry may store the filename without it being 0 ended, and you want that it would be copied here from 'm_name' buffer
	char* m_name_n;
// set this, if either want to ensure 0 ending at the proper place, or want to specify the size of buffer pointed by 'm_name', if 'm_name_n' is set
// even no, set this always, because the name will later be copied (and will be an assertion with its length)
#else
// extra validation of an entry
	bool m_name_always_zero_ended;
// extra validation of an entry; otherwise it allows encodings like a codepage or UTF-8
	bool m_name_is_ansi;
// set this always, because the name will later be copied, and 0-ending will there be ensured
#endif
// note, it can be 0, if the pack has no names stored in it
//// *a bit incorrectly named; but otherwise it should be something long, like 'm_name_len_max'
//	u32 m_name_len;
	u32 m_name_len_max;
// 32 bit size of a file content
	u32* m_data_len_32;
// filetime to use for a file being unpacked
	FILETIME* m_filetime_64;
// or this
	u32* m_filetimestamp_32;
// for this moment, there is sufficient stuff above (which though is messy a bit), to exclude a need of this function at all
// this function will be necessary only if the length of an entry will be volatile
	PackEntryReader_t m_entry_reader;
// this one is useful for 'IsOurFile()'-like checks
//	PackEntryCheck_t m_entry_check;
// if there is something specific with the name
//	PackEntryReadName_t m_entry_read_name;
	PackEntryGetName_t m_entry_get_name;
	PackEntryReaderPost_t m_entry_reader_post;
//	PackEntryWriter_t m_entry_writer;
	PackEntryForm_t m_entry_form;
	PackWriteFinish_t m_write_finish;
// files number is present in the header, or the size of the entries block is known, and the amount of files can be calculated
	bool m_has_files_num;
// a pack may have its limitation on the number of entries
//	u32 m_files_num_max;
	u32 m_entries_num_max;
// this allows to do an extra validation check, because an old packs obviously do not store big files
	u32 m_file_size_max;
// + reader-only configuration +
// entries and data are in a two separate blocks, and have to switch the filepointer when reading
//	bool m_swap_filepointers;
	bool m_read_swap_filepointer;
// - reader-only configuration -
// + writer-only configuration +
// where to store the entries
//	bool m_entries_after_data;
	bool m_write_entries_after_data;
// will a buffer be necessary, when will store the entries
// *similar to 'm_entries_after_data', because is 1 when it is 1, and is 0 when it is 0 (I don't see why I could need to have them separately, but still, lets ...)
	bool m_write_entries_store_in_a_buf;
	void* m_write_entries_buf;
	u32 m_write_entries_buf_size;
	void* m_write_entry_cur;
	u8 m_write_default_bytes_hdr;
	u8 m_write_default_bytes_entry;
	bool m_write_are_subdirectories_allowed;
// - writer-only configuration -
};

