// by Alexander Ilyin
// ID Games PAK files
// *look 'COM_LoadPackFile()' in "common.c" of Quake 1
// *look 'FS_LoadPackFile()' in "files.c" of Quake 2
// *look 'FindQuakeFilesInPak()' in "l_qfiles.c" of Quake 3 (and RTCWolfenstein)

#include "pak.h"
#include "error.h"
#include "pack_top.h"


#if 0
Pak::Pak ()
{
	memset (this, 0, sizeof(*this));
}
#endif

bool Pak::SetHdrBuf ()
{
	m_hdr_buf = &m_buf_hdr;
	m_hdr_size = sizeof(m_buf_hdr);
	return 1;
}

bool Pak::HdrParse (bool& is_valid)
{
	m_files_num = m_buf_hdr.dirlen / sizeof(m_buf_entry);
	m_entries_begin = m_buf_hdr.dirofs;
// the proportional dependence between two values in the header, allows to do an extra identification check
	is_valid = m_files_num * sizeof(m_buf_entry) == m_buf_hdr.dirlen;

	return 1;
}

bool Pak::TypeSetup ()
{
	bool r;

	r = SetupContainer ();
	if (! r)
		return 0;
	m_entry_data = &m_buf_entry;
	m_entry_len = sizeof(m_buf_entry);
	m_read_swap_filepointer = 1;
	m_data_offset_32 = &m_buf_entry.filepos;
	m_name = m_buf_entry.name;
// *'COM_LoadPackFile()' uses plain 'strcpy()' on it
	m_name_always_zero_ended = 1;
	m_name_len_max = sizeof(m_buf_entry.name) - 1;
	m_data_len_32 = &m_buf_entry.filelen;
	m_entry_reader_post = &Pak::EntryReaderPost;
	m_entry_form = &Pak::EntryForm;
	m_write_finish = &Pak::WriteFinish;
	m_has_files_num = 1;
// + writer-only configuration +
	m_write_entries_after_data = 1;
	m_write_entries_store_in_a_buf = 1;
// 0 for Quake, but Half-Life has a junk there
	m_write_default_bytes_entry = 0;
	m_write_are_subdirectories_allowed = 1;
// - writer-only configuration -

	return 1;
}

#if 1
bool Pak::EntryReaderPost (bool& is_valid)
{
	u32 i;

// convert "/" to "\", otherwise Total Commander will fail to open such file
	for (i = 0; i < m_name_len_max; i++)
	{
		char c;
		c = m_name[i];
		if (! c)
			break;
		if (c == '/')
			m_name[i] = '\\';
	}
	return 1;
}
#endif

bool Pak::EntryForm ()
{
//	bool r;

	m_buf_entry.filepos = m_data_offset_cur;
	m_buf_entry.filelen = m_data_len;
	return 1;
}

bool Pak::WriteFinish ()
{
	m_buf_hdr.dirofs = m_entries_begin;
	m_buf_hdr.dirlen = m_write_entries_buf_size;
	return 1;
}

