// by Alexander Ilyin

#include <windows.h>
//#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
//#include <math.h>
//#include <io.h>
#include <sys/stat.h>
#include <direct.h>
#include <string>
using namespace std;
#include "types.h"
//#include "plugin.h"
#include "error.h"
#include "macros.h"
#include "pack_export.h"
//#include "pack_base.h"


#define PLUGIN_NAME "pack.wcx"
GetFormatNames_t* GetFormatNames_p = 0;
Pack_Create_t* Pack_Create_p = 0;
Pack_Destroy_t* Pack_Destroy_p = 0;


#define AQUIRE_FUNC(_name) \
	func_name = #_name; \
	*(FARPROC*)&_name##_p = GetProcAddress (hmod, func_name); \
	if (! _name##_p) \
		goto function_get_fail;

bool LoadDLL ()
{
	HMODULE hmod;
	const char* func_name;

	hmod = LoadLibrary (PLUGIN_NAME);
	if (! hmod)
	{
		printf ("failed to load \"" PLUGIN_NAME "\" library file\n");
		return 0;
	}

	AQUIRE_FUNC(GetFormatNames);
	AQUIRE_FUNC(Pack_Create);
	AQUIRE_FUNC(Pack_Destroy);

	return 1;

function_get_fail:
	printf ("failed to get address of '%s()' subr. from \"" PLUGIN_NAME "\" library\n", func_name);
	return 0;
}

int __stdcall ProcessDataProc (char* filename, int size)
{
	static u32 bytes_processed = 0;

	bytes_processed += size;
	printf ("bytes processed :  %u\n", bytes_processed);
	printf ("file :  \"%s\"\n", filename);

	return 1;
}

int main (int argc, char* argv[])
{
	bool r;
	u32 i;
//	string unpack_dir;
	PackExports* pack;
	const char* filepath;

#if 1
	char cur_dir[1024];
	DWORD D;

//	D = GetCurrentDirectory (sizeof(cur_dir), cur_dir);
	D = GetCurrentDirectory (sizeof(cur_dir) - 1, cur_dir);
	if (! D)
	{
		printf ("GetCurrentDirectory() failed\n");
		return -1;
	}
	if (D > sizeof(cur_dir) - 1)
	{
		printf ("path for the current directory is too long ('GetCurrentDirectory()' required a bigger buffer of %u characters, than given one of %u size)\n", D - 1, sizeof(cur_dir) - 1);
		return -1;
	}
#if 0
	printf ("current directory is :\n");
	printf ("\"%s\"\n", cur_dir);
#endif
#endif

#if 0
	FORI0(argc)
	{
		printf ("%s\n", argv[i]);
	}
#endif

	r = LoadDLL ();
	if (! r)
		goto exit_with_error;

//	if (argc != 4)
	if (argc != 3)
	{
//		printf ("need exactly 3 arguments, got %u\n", argc - 1);
		printf ("need exactly 2 arguments, got %u\n", argc - 1);
		goto print_usage;
	}

	const char* dir_path;
	struct _stat statbuf;
	dir_path = argv[1];
// oops, no need
#if 0
	unpack_dir = argv[1];
	unpack_dir += ;
	dir_path = unpack_dir.c_str();
#endif
	i = _stat (dir_path, &statbuf);
	if (i)
// failed to obtain stat for that path
	{
		i = _mkdir (dir_path);
		if (i)
// failed to create dir
		{
			printf ("Can't create directory \"%s\", error %i\n", dir_path, errno);
		}
	}
	else
	{
		if (! (statbuf.st_mode & _S_IFDIR))
		{
			Error ("Can't create directory \"%s\", a file with that name exists.", dir_path);
		}
	}

//	__asm int 3
	A(Pack_Create_p);
	pack = Pack_Create_p ();
	if (! pack)
	{
//		printf ("failed to create 'Pack' class (out of memory ?)\n");
		printf ("failed to create 'Pack' class (out of memory)\n");
		goto exit_with_error;
	}

	filepath = argv[2];
	r = pack->Open (0, 0, filepath);
	if (! r)
	{
		printf ("failed to open file \"%s\"\n", filepath);
		goto pack_error;
	}

	r = pack->ReadHdr ();
	if (! r)
	{
		printf ("failed to read file header \"%s\"\n", filepath);
		goto pack_error;
	}

	while (1)
	{
		bool has_more;

		r = pack->HasMoreFiles (has_more);
		if (! r)
		{
			printf ("failed to aquire next file in \"%s\"\n", filepath);
			goto pack_error;
		}
		if (! has_more)
			break;

		r = pack->ReadEntry ();
		if (! r)
		{
			printf ("failed to read entry in file \"%s\"\n", filepath);
			goto pack_error;
		}

		u32 buf_size;
		string s;
		char buf[1024];

		r = pack->GetEntryNameRequiredBufSize (buf_size);
		if (! r)
			goto pack_error;
// *we currently don't have a formats which could require a higher size
		A(buf_size <= sizeof(buf));

		r = pack->GetEntryName (buf);
		if (! r)
			goto pack_error;

		s = dir_path;
//		__asm int 3
		s += '\\';
//		s += "out.1";
		s += buf;
		r = pack->CopyToFile (0, s.c_str());
		if (! r)
		{
			printf ("failed to read file \"%s\" in file \"%s\"\n", 0, filepath);
			goto pack_error;
		}
	}

	r = pack->Close ();
	if (! r)
	{
		printf ("failed to close file \"%s\"\n", filepath);
		goto pack_error;
	}

	A(Pack_Destroy_p);
	Pack_Destroy_p (pack);

	printf ("done unpacking\n");

#if 0
finish:
	if (! result)
		goto exit_with_error;
#endif
	return 0;

print_usage:
	printf ("usage :  unpack.exe <output directory> <input file>\n");
	const char** format_names_list;
	u32 names_num;
	A(GetFormatNames_p);
	GetFormatNames_p (format_names_list, names_num);
	printf ("supported file formats are :\n");
	{
	FORII0(names_num)
	{
		if (ii)
			printf (", ");
		printf ("%s", format_names_list[ii]);
	}
	}
	printf ("\n");
	goto exit_with_error;

pack_error:
	A(pack->m_error < NUMOF(pack_errors));
	printf ("error :  %s\n", pack_errors[pack->m_error]);
	goto exit_with_error;

exit_with_error:
#if 1
	printf ("press any key to exit ...");
	while (1)
	{
		if (_kbhit ())
			break;
		Sleep (50);
	}
	printf ("\n");
#endif
	return -1;
}

