// by Alexander Ilyin
// ID Games WAD 2 (Quake 1) and 3 (Half-Life) files
// in src of Quake 1, "wad.c", 'W_LoadWadFile()', 'wadinfo_t', 'lumpinfo_t'

#include "wad3.h"
#include "error.h"
#include "pack_top.h"
//#include "macros.h"


#if 0
Wad3::Wad3 ()
{
	memset (this, 0, sizeof(*this));
}
#endif

bool Wad3::SetHdrBuf ()
{
	m_hdr_buf = &m_buf_hdr;
	m_hdr_size = sizeof(m_buf_hdr);
	return 1;
}

bool Wad3::HdrParse (bool& is_valid)
{
	m_files_num = m_buf_hdr.numentries;
	m_entries_begin = m_buf_hdr.diroffset;
// some checks
	is_valid = m_entries_begin >= 4 + sizeof(m_buf_hdr);
	is_valid &= (m_entries_begin <= m_file.m_len);

	return 1;
}

bool Wad3::TypeSetup ()
{
	bool r;

	r = SetupContainer ();
	if (! r)
		return 0;
	m_entry_data = &m_buf_entry;
	m_entry_len = sizeof(m_buf_entry);
	m_read_swap_filepointer = 1;
	m_data_offset_32 = &m_buf_entry.offset;
//	m_name = m_buf_entry.name;
	m_name = m_name_buf;
// *in 'lumpinfo_t::name' it is expected to be always 0 ended, but it is not being ensured, thus it (the engine) theoretically may crash if it will not be 0 ended
// *in the intermediate buffer it will be 0 ended
	m_name_always_zero_ended = 1;
//	m_name_always_zero_ended = 0;
//	m_name_len_max = sizeof(m_buf_entry.name) - 1;
//	m_name_len_max = sizeof(m_buf_entry.name);
	m_name_len_max = sizeof(m_name_buf) - 1;
	m_data_len_32 = &m_buf_entry.size_packed;
	m_entry_get_name = &Wad3::EntryGetName;
//	m_entry_reader_post = &Wad3::EntryReaderPost;
	m_entry_form = &Wad3::EntryForm;
	m_write_finish = &Wad3::WriteFinish;
	m_has_files_num = 1;
// + writer-only configuration +
	m_write_entries_after_data = 1;
	m_write_entries_store_in_a_buf = 1;
// 0 for Doom 1 and 2
	m_write_default_bytes_entry = 0;
	m_write_are_subdirectories_allowed = 0;
// - writer-only configuration -

	return 1;
}

bool Wad3::EntryGetName ()
{
#if 1
// copy to buffer
// check that the buffer would have enough place to add an extension
	A(sizeof(m_name_buf) >= sizeof(m_buf_entry.name) + 1 + 7);
	memcpy (m_name_buf, m_buf_entry.name, sizeof(m_buf_entry.name));
// ensure 0 ending
	m_name_buf[sizeof(m_buf_entry.name)] = 0;
// *idk the actual extension
//	strcat (m_name_buf, ".texture");
#endif
// *all are 'C'
//	if (m_buf_entry.type)
//	if (m_buf_entry.type != 'C')
//		m_buf_entry.type = m_buf_entry.type;
// *I didn't get a compressed one yet
	if (m_buf_entry.compression)
		goto not_supported;
	return 1;

not_supported:
	m_error = PACK_ERR__UNSUPPORTED_ENTRY_TYPE;
	return 0;
}

bool Wad3::EntryForm ()
{
//	bool r;
	u32 len;

	len = strlen (m_name_buf);
	if (len >= sizeof(m_buf_entry.name))
	{
		m_error = PACK_ERR__FILENAME_INCOMPATIBLE;
		return 0;
	}
// copy and zero the remainder
	strncpy (m_buf_entry.name, m_name_buf, sizeof(m_buf_entry.name));
	m_buf_entry.offset = m_data_offset_cur;
	m_buf_entry.size_packed = m_data_len;
	m_buf_entry.size_unpacked = m_data_len;
	m_buf_entry.type = 'C';
	m_buf_entry.compression = 0;
	m_buf_entry._align = 0;
	return 1;
}

bool Wad3::WriteFinish ()
{
	m_buf_hdr.numentries = m_file_ix;
	m_buf_hdr.diroffset = m_entries_begin;
	return 1;
}

