#pragma once

#include "types.h"
#include "pack_base.h"


#pragma pack(push, 1)

struct wad3_header_t
{
//	char id[4];
	u32 numentries;
	u32 diroffset;
};

// I don't know how WAD 2 differs from WAD 3, except that these values are signed
struct wad3_entry_t
{
	u32 offset;
	u32 size_packed;
	u32 size_unpacked;
	u8 type;
	u8 compression;
	u16 _align;
	char name[16];
};

#pragma pack(pop)

class Wad3 : virtual public PackBase
{
public:
//	Wad3 ();
	bool SetHdrBuf ();
	bool HdrParse (bool& is_valid);
	bool TypeSetup ();
	bool EntryGetName ();
//	bool EntryReaderPost (bool& is_valid);
	bool EntryForm ();
	bool WriteFinish ();

public:
	wad3_header_t m_buf_hdr;
	wad3_entry_t m_buf_entry;
	char m_name_buf[32];
};

